Status: Closed Start date: 2010-05-25

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: UI Estimated time: 0.00 hour

Target version: 4.0.0   

Resolution: Fixed Affected version:  

Description

In workflow settings, it is configurable whether the current status can transit to the same status or not, though it is self-evident that

the current status can transit to the same status.

 

Related issues:

Related to Redmine - Feature #5816: New issue initial status should be settab... Closed 2010-07-05

Related to Redmine - Patch #16364: Issue workflow doesn't force status transi... New

Associated revisions

Revision 17487 - 2018-09-15 09:09 - Jean-Philippe Lang

Disable workflow checkboxes with no status change (#5593).

Patch by Mizuki ISHIKAWA.

History

#1 - 2010-07-05 09:48 - Norbert Bérci

+1

Is it possible to apply Yuki Kita's patch? It seems extremely simple, but improves greately the UI (removes confusion about why are there same issue

transitions).

#2 - 2010-07-07 20:24 - Thomas Pihl

It does look nice. But...

Sometimes we only allow users to create new issues, not change any state. Then we would check the new/new checkbox. How would we solve that?

#3 - 2010-07-08 01:47 - Yuki Kita

Thomas Pihl wrote:

It does look nice. But...

Sometimes we only allow users to create new issues, not change any state. Then we would check the new/new checkbox. How would we solve

that?

 You do not have to check the new/new checkbox to prohibit users from changing state.

Instead of doing it, uncheck all checkbox and set the default value of issue statuses to "new".

I think this solves your concern.
#4 - 2010-07-08 03:10 - yusuke kokubo

+ 1

#5 - 2010-07-08 03:29 - Akiko Takano

+ 1

#6 - 2010-07-08 20:37 - Norbert Bérci

To those interested: let's discuss #5816 (about the initial statuses).

#7 - 2012-01-13 13:05 - Terence Mill

+1

Small but easy embeddable enhancement!

#8 - 2014-07-13 07:39 - Go MAEDA

- File 5593-r13306.diff added

+1

I have made Yuki Kita's patch compatible with current trunk(Redmine 2.5.2.devel.13306).

#9 - 2015-07-29 07:44 - Mischa The Evil

- Target version set to Candidate for next major release

#10 - 2016-12-30 09:04 - Go MAEDA

- Related to Patch #16364: Issue workflow doesn't force status transition though workflow is defined so added

#11 - 2018-02-25 08:12 - Go MAEDA

- File 5593-r17212.diff added

- File 5593-before@2x.png added

- File 5593-after@2x.png added

Updated the patch for the current trunk.

Before:

 

After:
#12 - 2018-02-25 12:04 - Bernhard Rohloff

+1

This patch also provides great reference points within the checkbox matrix.

#13 - 2018-02-25 16:47 - Marius BĂLTEANU

- File tests_for_5593.patch added

+1

Attached is a patch that fixes an existing failing test and adds a test for Go Maeda's patch.

#14 - 2018-02-25 17:04 - Marius BĂLTEANU

Reading the tickets and comments from the related issue (#16364) where some users request the "force status transition" feature, I'm wondering if is

better to show a disabled checked checkbox instead of "-" in order to make more obvious for the users that the "transition" between the same status is

allowed and it cannot be disabled.

#15 - 2018-02-26 01:29 - Go MAEDA

- File 5593-note14@2x.png added

Marius BALTEANU wrote:

I'm wondering if is better to show a disabled checked checkbox instead of "-" in order to make more obvious for the users that the "transition"

between the same status is allowed and it cannot be disabled.

 That makes sense. Do you mean like this?

 

#16 - 2018-02-26 10:41 - Bernhard Rohloff

Marius' suggestion is a neat additional improvement. It coherently presents the current implementation but lets room for future changes without

changing parts of the UI.

So if #16364 gets a thing someday, all we have to do is activating the checkboxes again.

#17 - 2018-02-26 22:39 - Marius BĂLTEANU

Go MAEDA wrote:

That makes sense. Do you mean like this?

 Exactly.

#18 - 2018-03-07 09:56 - Mischa The Evil

- Subject changed from Meanless settings for workflow to Meaningless settings for workflow

- Target version changed from Candidate for next major release to 4.0.0

#19 - 2018-03-14 06:14 - Mizuki ISHIKAWA

- File 5593-r17235.patch added

I think Marius' suggestion is good as well.
I updated the patch to add disabled checkbox instead of "-".

#20 - 2018-03-14 07:00 - Mizuki ISHIKAWA

- File 5593-r17235-2.patch added

Fixed disabled checkbox not to be affected by toggleCheckboxesBySelector.

#21 - 2018-03-19 14:16 - Go MAEDA

- File wrong-color@2x.png added

Mizuki, thank you for posting the patch.

But I found that transitions whose source status and destination status are the same are displayed in a different color under certain conditions. Could

you look into this and update the patch?

Steps to reproduce:

1. Before applying the patch, edit the workflow for "Manager" - "Bug", check all transitions and save. Every transition is displayed in green.

2. Uncheck the checkbox for "New" -> "New" transition and save. "New" -> "New" transition should be displayed in white.

3. Apply the patch 5593-r17235-2.patch

4. Check "Manager" - "Bug" workflow. Transitions like "New" -> "New" and "Assigned -> Assigned" are checked and disabled. Although checked

statuses should displayed in green but "New" -> "New" status (unchecked in step 2) is displayed in white.

 wrong-color@2x.png 

#22 - 2018-03-22 01:17 - Mizuki ISHIKAWA

- File 5593-r17236.patch added

I attached a patch that corrected the problem pointed out to Go MAEDA.

I mainly added the following changes.

diff --git a/app/views/workflows/_form.html.erb b/app/views/workflows/_form.html.erb

index 3fc69c4f5..542db4e35 100644

--- a/app/views/workflows/_form.html.erb

+++ b/app/views/workflows/_form.html.erb

@@ -38,7 +38,7 @@

       <% end %>

     </td>

     <% for new_status in @statuses -%>

-    <% checked = workflows.detect {|w| w.old_status == old_status && w.new_status == new_status} %>

+    <% checked = (old_status == new_status) || workflows.detect {|w| w.old_status == old_status && w.new_stat

us == new_status} %>

     <td class="<%= checked ? 'enabled' : '' %>" title="<%= old_status_name %> &#187; <%= new_status.name %>">

       <%= transition_tag workflows, old_status, new_status, name %>

     </td>

 But there is one problem with this patch.

The state of workflow is saved as WorkflowTransition. (Even when the source status and the destination status are the same)

When a patch is applied, the checkbox displayed will be checked, even if the data indicates that it is not checked the checkbox.

That is, the data and the displayed results are contradictory.

I think it is difficult to display a disabled checkbox while maintaining consistency with the data.

#23 - 2018-03-22 23:54 - Marius BĂLTEANU

Mizuki ISHIKAWA wrote:

When a patch is applied, the checkbox displayed will be checked, even if the data indicates that it is not checked the checkbox.

That is, the data and the displayed results are contradictory.

 You're worried that the displayed results are not according with the data from the database? For ex: In the UI, the checkbox for New -> New is

checked and disabled, but in the db there is no entry in the WorkflowTransition for the transition (I'm asking just to confirm that I understand correctly).

If yes, I don't see a real problem from the following reasons:

- is not a real inconsistency because you don't really need a transition to update a ticket without changing the status.

- only a few users can observe this inconsistency and they need to be quite technical to deep in Redmine code and database.

#24 - 2018-04-02 09:13 - Mizuki ISHIKAWA
Marius BALTEANU wrote:

Mizuki ISHIKAWA wrote:

When a patch is applied, the checkbox displayed will be checked, even if the data indicates that it is not checked the checkbox.

That is, the data and the displayed results are contradictory.

 You're worried that the displayed results are not according with the data from the database? For ex: In the UI, the checkbox for New -> New is

checked and disabled, but in the db there is no entry in the WorkflowTransition for the transition (I'm asking just to confirm that I understand

correctly).

 Yes, I was worried about it.

If yes, I don't see a real problem from the following reasons:

- is not a real inconsistency because you don't really need a transition to update a ticket without changing the status.

- only a few users can observe this inconsistency and they need to be quite technical to deep in Redmine code and database.

 Certainly, I think that few people feel strange about this problem.

I seemed to be over-thinking about it problem.

Thank you for checking, Marius BALTEANU.

#25 - 2018-09-15 09:11 - Jean-Philippe Lang

- Subject changed from Meaningless settings for workflow to Grey out workflow checkboxes for transitions to the same status

- Status changed from New to Closed

- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

Committed, thanks.
